#Create a simulator object
set ns [new Simulator]
$ns color 1 black
$ns color 101 red
$ns color 102 blue
$ns color 103 green
$ns color 104 white

#Open a trace file
set nf [open out.nam w]

# Trace Options
set tracefd  [open set.tr w]


#Define a 'finish' procedure
proc finish {} {
        global ns nf  tracefd
        $ns flush-trace
	close $tracefd
        close $nf
        exec nam out.nam &
        exit 0
}

#Create three nodes
set n0 [$ns node]
set n1 [$ns node]
set n2 [$ns node]
$n2 color "chocolate"
$n2 shape "square"
set n3 [$ns node]
$n3 shape "square"
$n3 color "chocolate"
set n4 [$ns node]
set n5 [$ns node]
#Connect the nodes with two links
$ns trace-all $tracefd 
$ns namtrace-all $nf

$ns duplex-link $n4 $n5 1Mb 10ms DropTail
$ns duplex-link-op $n4 $n5 orient 270deg
$ns duplex-link $n3 $n4 1Mb 10ms DropTail
$ns duplex-link-op $n3 $n4 orient 45deg
$ns duplex-link $n2 $n3 38.4Kb 30ms DropTail
$ns duplex-link-op $n2 $n3 color "chocolate"
$ns duplex-link-op $n2 $n3 label "radio link"
$ns duplex-link-op $n2 $n3 orient right
$ns duplex-link $n1 $n2 1Mb 10ms DropTail
$ns duplex-link-op $n1 $n2 orient 315deg
$ns duplex-link $n0 $n1 1Mb 10ms DropTail
$ns duplex-link-op $n0 $n1 orient 90deg

# Create a loss model
 set em_ [new ErrorModel]
$em_ set rate_ 0.3
#$ns link-lossmodel $em_ $n2 $n3
		set j 0
		set tmp1($j) [new ErrorModel/Uniform 0 pkt]
		set tmp2($j) [new ErrorModel/Uniform 1 pkt]
		set m_states($j) [ list $tmp1($j) $tmp2($j)]
		set m_periods($j) [list 0.02 0.02]
		set m_transmx($j) { {0.97 0.03}
				{0.12 0.88}}
		set m_trunit($j) pkt
		set m_sttype($j) time
		set m_nstates($j) 2
		set m_nstart($j) [lindex $m_states($j) 0]
#	set em_ [new ErrorModel/MultiState $m_states($j)\
 $m_periods($j) $m_transmx($j) $m_trunit($j) $m_sttype($j) $m_nstates($j)  $m_nstart($j)]

$ns link-lossmodel $em_ $n2 $n3
set em1_ [new ErrorModel]
$em1_ set rate_ 0.0
$ns link-lossmodel $em1_ $n3 $n2

##### queue limit
#$ns queue-limit $n2 $n3  2000
#$ns queue-limit $n3 $n2  2000

#set tff [open simp.out.tr2 w]
#$ns trace-queue $n2 $n3 $tff
#$ns trace-queue $n0 $n1 $tff
#$ns trace-queue $n1 $n0 $tff
#$ns trace-queue $n5 $n4 $tff


set p0 [new Agent/CBR]
$p0 set packetSize_ 19000
$p0 set interval_ 10s
$p0 set class_ 0
$ns attach-agent $n0 $p0


set p1 [new Agent/Ppp]
$ns attach-agent $n2 $p1

set tcp_pass_n2 [new Agent/Ppp]
$ns attach-agent $n2 $tcp_pass_n2 

####          #### p1 -- --- p2 
set p2 [new Agent/Rlp]
$ns attach-agent $n2 $p2
$p2 set rawrate_ 9.6
$p2 set rlp_delay 13


set tcp_rlp_n2 [new Agent/Rlp]
$ns attach-agent $n2 $tcp_rlp_n2
#$tcp_rlp_n2 errmodel $em1_
$tcp_rlp_n2 set rawrate_ 9.6
$tcp_rlp_n2 set rlp_delay 13
####          #### p2 ---Rlp --- p3 
set p3 [new Agent/Rlp]
$ns attach-agent $n3 $p3
$p3 set rawrate_ 9.6
$p3 set rlp_delay 13
$p3 errmodel $em_

set tcp_rlp_n3 [new Agent/Rlp]
$ns attach-agent $n3 $tcp_rlp_n3
#$tcp_rlp_n3 errmodel $em_
$tcp_rlp_n3 set rawrate_ 9.6
$tcp_rlp_n3 set rlp_delay 13
####          #### p3 --- --- p4 
set p4 [new Agent/Ppp]
$ns attach-agent $n3 $p4

set tcp_pass_n3 [new Agent/Ppp]
$ns attach-agent $n3 $tcp_pass_n3

####          #### p4 ---CBR --- p5 
set p5 [new Agent/Null]
$ns attach-agent $n5 $p5

set tcp_sender [new Agent/TCP/Reno]
$tcp_sender set packetSize_ 384
$tcp_sender set class_ 1
$ns attach-agent $n0 $tcp_sender
$ns add-agent-trace $tcp_sender tcp_source
set ftp [new Application/FTP]
$ftp attach-agent $tcp_sender

set sink [new Agent/TCPSink]
$ns attach-agent $n5 $sink
$ns add-agent-trace $sink tcp_sink
#$ns connect $tcp $sink


$p1 dst $p2
$p2 dst $p1
$p3 dst $p4
$p4 dst $p3

$tcp_pass_n2 dst $tcp_rlp_n2
$tcp_rlp_n2 dst $tcp_pass_n2
$tcp_pass_n3 dst $tcp_rlp_n3
$tcp_rlp_n3 dst $tcp_pass_n3


#Connect the two agents
$ns connect $p0 $p1
$ns connect $p2 $p3
$ns connect $p4 $p5

$ns connect $tcp_sender $tcp_pass_n2
$ns connect $tcp_rlp_n3 $tcp_rlp_n2
$ns connect $tcp_pass_n3 $sink

#Schedule events
#$ns at 0.01 "$p0 start"
$ns at 0 "$ftp send 100000"
$ns at 20 "finish"
$ns at 0.0 "$ns trace-annotate \"Packet/Frame Color Legend:\""
$ns at 0.0 "$ns trace-annotate \"--------------------------\""
$ns at 0.0 "$ns trace-annotate \"BLACK : IP packet\""
$ns at 0.0 "$ns trace-annotate \"GREEN : RLP new data frame\""
$ns at 0.0 "$ns trace-annotate \"BLUE : RLP retransmitted data frame\""
$ns at 0.0 "$ns trace-annotate \"RED : RLP NAK frame\""
$ns at 0.0 "$ns trace-annotate \"WHITE : RLP idle frame\""
#$ns at 0.0 "$ns set-animation-rate 4ms"
#Run the simulation
$ns run


